<?php
// $Id: template.php,v 1.1.2.1 2009/12/31 16:23:23 psynaptic Exp $

/**
 * Override or insert variables into the page templates.
 *
 * @param $vars
 *   An array of variables to pass to the theme template.
 * @param $hook
 *   The name of the template being rendered ("page" in this case.)
 */
function clean_960gs_preprocess_page(&$vars, $hook) {
  $container_classes = array();
  $full_grid_classes = array();
  $main_classes = array();
  $left_classes = array();
  $content_classes = array();
  $right_classes = array();

  // Allow modules and themes to add to the classes. @todo: accept only arrays?
  if ($vars['container_classes']) {
    $container_classes = array($vars['container_classes']);
  }
  if ($vars['full_grid_classes']) {
    $full_grid_classes = array($vars['full_grid_classes']);
  }
  if ($vars['main_classes']) {
    $main_classes = array($vars['main_classes']);
  }
  if ($vars['left_classes']) {
    $left_classes = array($vars['left_classes']);
  }
  if ($vars['content_classes']) {
    $content_classes = array($vars['content_classes']);
  }
  if ($vars['right_classes']) {
    $right_classes = array($vars['right_classes']);
  }

  // Dynamic layout classes.
  $columns = theme_get_setting('clean_960gs_columns');

  // 12 columns.
  if ($columns == 12) {
    $container_classes[] = 'container_12';
    $full_grid_classes[] = 'grid_12';
    $main_classes[] = 'grid_12';

    switch ($vars['layout']) {
      case 'both':
        $left_classes[] = 'grid_3';
        $content_classes[] = 'grid_6';
        $right_classes[] = 'grid_3';
        break;
      case 'none':
        $content_classes[] = 'grid_12';
        $content_classes[] = 'alpha';
        $content_classes[] = 'omega';
        break;
      case 'left':
        $left_classes[] = 'grid_3';
        $content_classes[] = 'grid_9';
        $content_classes[] = 'omega';
        break;
      case 'right':
        $content_classes[] = 'grid_9';
        $content_classes[] = 'alpha';
        $right_classes[] = 'grid_3';
        break;
    }
  }

  // 16 columns.
  else {
    $container_classes[] = 'container_16';
    $full_grid_classes[] = 'grid_16';
    $main_classes[] = 'grid_16';

    switch ($vars['layout']) {
      case 'both':
        $left_classes[] = 'grid_4';
        $content_classes[] = 'grid_8';
        $right_classes[] = 'grid_4';
        break;
      case 'none':
        $content_classes[] = 'grid_16';
        $content_classes[] = 'alpha';
        $content_classes[] = 'omega';
        break;
      case 'left':
        $left_classes[] = 'grid_4';
        $content_classes[] = 'grid_12';
        $content_classes[] = 'omega';
        break;
      case 'right':
        $content_classes[] = 'grid_12';
        $content_classes[] = 'alpha';
        $right_classes[] = 'grid_4';
        break;
    }
  }

  // Generic classes, unlikey to need changing.
  $container_classes[] = 'clear-block';
  $main_classes[] = 'clear-block';
  $left_classes[] = 'alpha';
  $left_classes[] = 'sidebar';
  $content_classes[] = 'clear-block';
  $right_classes[] = 'omega';
  $right_classes[] = 'sidebar';

  $vars['container_attr']['class'] .= implode(' ', $container_classes);
  $vars['full_grid_attr']['class'] .= implode(' ', $full_grid_classes);
  $vars['main_attr']['id'] = 'main';
  $vars['main_attr']['class'] .= implode(' ', $main_classes);
  $vars['left_attr']['id'] = 'left';
  $vars['left_attr']['class'] .= implode(' ', $left_classes);
  $vars['content_attr']['id'] = 'content';
  $vars['content_attr']['class'] .= implode(' ', $content_classes);
  $vars['right_attr']['id'] = 'right';
  $vars['right_attr']['class'] .= implode(' ', $right_classes);
}
